﻿Imports Microsoft.Kinect
Class MainWindow
    Private myKinectSensor As KinectSensor
    Private myDepthFrameReader As DepthFrameReader = Nothing
    Private myBytesPerPixel As Integer
    Private DepthImageFrameData() As UShort
    Private DepthImageBitmapRect As Int32Rect
    Private DepthImageStride As Integer
    Private DepthImageBitmap As WriteableBitmap

    Private Sub MainWindow_Loaded(sender As Object, e As RoutedEventArgs) Handles Me.Loaded
        myKinectSensor = KinectSensor.GetDefault

        If myKinectSensor Is Nothing = False Then
            myDepthFrameReader = myKinectSensor.DepthFrameSource.OpenReader
            Dim myDepthFrameDescripton As FrameDescription = myKinectSensor.DepthFrameSource.FrameDescription

            DepthImageBitmap = New WriteableBitmap(myDepthFrameDescripton.Width, myDepthFrameDescripton.Height, 96.0, 96.0, PixelFormats.Gray8, Nothing)
            myBytesPerPixel = myDepthFrameDescripton.BytesPerPixel
            DepthImageFrameData = New UShort(myDepthFrameDescripton.Width * myDepthFrameDescripton.Height - 1) {}
            DepthImageBitmapRect = New Int32Rect(0, 0, myDepthFrameDescripton.Width, myDepthFrameDescripton.Height)
            DepthImageStride = myDepthFrameDescripton.Width * myBytesPerPixel
            AddHandler myDepthFrameReader.FrameArrived, AddressOf myDepthFrameReader_FrameArrived
            myKinectSensor.Open()
        End If
    End Sub

    Private Sub myDepthFrameReader_FrameArrived(sender As Object, e As DepthFrameArrivedEventArgs)
        Using myDepthFrame As DepthFrame = e.FrameReference.AcquireFrame
            If myDepthFrame Is Nothing = False Then
                myDepthFrame.CopyFrameDataToArray(DepthImageFrameData)
                DepthImageBitmap.WritePixels(DepthImageBitmapRect, DepthImageFrameData, DepthImageStride, 0)
                Image1.Source = DepthImageBitmap
            End If
        End Using
    End Sub

    Private Sub MainWindow_Closing(sender As Object, e As ComponentModel.CancelEventArgs) Handles Me.Closing
        If myDepthFrameReader Is Nothing = False Then
            myDepthFrameReader.Dispose()
            myDepthFrameReader = Nothing
        End If

        If myKinectSensor Is Nothing = False Then
            myKinectSensor.Close()
            myKinectSensor = Nothing
        End If
    End Sub
End Class

